package xyz.tbvns.rogue_block.Managers.registeredSavable;

import net.minecraft.server.network.ServerPlayerEntity;
import xyz.tbvns.rogue_block.Managers.Savable;
import xyz.tbvns.rogue_block.Packets.PacketManager;
import xyz.tbvns.rogue_block.Upgrades.Upgrade;

import java.util.ArrayList;
import java.util.List;

public class PlayerData implements Savable {
    private int points = 0;
    private List<Class<? extends Upgrade>> upgrades = new ArrayList<>();
    public void setPoints(int points) {
        this.points = points;
    }

    public int addPoints(ServerPlayerEntity entity, int amount) {
        points += amount;
        syncWithClient(entity);
        return points;
    }

    public int getPoints() {
        return points;
    }

    public void addUpgrade(ServerPlayerEntity entity, Class<? extends Upgrade> upgrade) {
        upgrades.add(upgrade);
        syncWithClient(entity);
    }

    public void removeUpgrade(ServerPlayerEntity entity, Class<? extends Upgrade> upgrade) {
        upgrades.remove(upgrade);
        syncWithClient(entity);
    }

    //TODO: replace that with lombok
    public List<Class<? extends Upgrade>> getUpgrades() {
        return upgrades;
    }

    @Override
    public void syncWithClient(ServerPlayerEntity entity) {
        PacketManager.sendUpgradePacket(entity, this);
    }
}
