package xyz.tbvns.rogue_block.Network;

import net.fabricmc.fabric.api.networking.v1.ServerPlayNetworking;
import net.minecraft.text.Text;
import net.minecraft.util.Identifier;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import xyz.tbvns.rogue_block.Managers.DataManager;
import xyz.tbvns.rogue_block.Managers.registeredSavable.PlayerData;
import xyz.tbvns.rogue_block.Packets.registeredPackets.BuyUpgradePacket;
import xyz.tbvns.rogue_block.Upgrades.Upgrade;
import xyz.tbvns.rogue_block.Upgrades.UpgradesManager;

public class ServerNetworkManager {
    private static final Logger log = LoggerFactory.getLogger(ServerNetworkManager.class);

    public static void setup() {
        ServerPlayNetworking.registerGlobalReceiver(BuyUpgradePacket.ID, (payload, context) -> {
            BuyUpgradePacket packet = (BuyUpgradePacket) payload;
            Upgrade upgrade = UpgradesManager.getUpgradeById(Identifier.of(packet.getUpgrade()));
            if (upgrade == null) {
                context.player().networkHandler.disconnect(Text.of("Invalid upgrade"));
                log.error("Player {} tried to buy an upgrade that doesn't exist !", context.player().getName());
                return;
            }
            PlayerData data = DataManager.getPlayerState(context.player());
            if (data.getPoints() < upgrade.getCost()) {
                context.player().networkHandler.disconnect(Text.of("Invalid packet (desync ?)"));
                log.error("Player {} tried to buy an upgrade without enough money !", context.player().getName());
                return;
            }
            data.addPoints(context.player(), -upgrade.getCost());
            data.addUpgrade(context.player(), upgrade.getClass());
            log.info("Player {} bought the upgrade {}.", context.player().getName(), upgrade.getName());
        });
    }
}
