package xyz.tbvns.rogue_block;

import net.fabricmc.api.ModInitializer;
import net.fabricmc.fabric.api.event.lifecycle.v1.ServerLifecycleEvents;
import net.fabricmc.fabric.api.event.player.UseBlockCallback;
import net.fabricmc.fabric.api.networking.v1.PayloadTypeRegistry;
import net.fabricmc.fabric.api.networking.v1.ServerPlayConnectionEvents;
import net.fabricmc.fabric.api.networking.v1.ServerPlayNetworking;
import xyz.tbvns.rogue_block.Events.PlayerJoinEvents;
import xyz.tbvns.rogue_block.Events.PlayerStartButtonEvent;
import xyz.tbvns.rogue_block.Events.ServerStartEvent;
import xyz.tbvns.rogue_block.Managers.DataManager;
import xyz.tbvns.rogue_block.Network.ServerNetworkManager;
import xyz.tbvns.rogue_block.Packets.PacketManager;
import xyz.tbvns.rogue_block.Packets.registeredPackets.BuyUpgradePacket;
import xyz.tbvns.rogue_block.Packets.registeredPackets.PlayerDataPacket;
import xyz.tbvns.rogue_block.Upgrades.UpgradesManager;

public class Rogue_block implements ModInitializer {
    public static final String MOD_ID = "rogue_block";

    @Override
    public void onInitialize() {
        ServerPlayConnectionEvents.JOIN.register(new PlayerJoinEvents());
        UseBlockCallback.EVENT.register(new PlayerStartButtonEvent());
        ServerLifecycleEvents.SERVER_STARTED.register(new ServerStartEvent());

        PayloadTypeRegistry.playS2C().register(PlayerDataPacket.PlayerDataPacketID, PlayerDataPacket.CODEC);
        PayloadTypeRegistry.playC2S().register(BuyUpgradePacket.ID, BuyUpgradePacket.CODEC);

        UpgradesManager.loadUpgrades();
        PacketManager.setup();
        DataManager.setup();
        ServerNetworkManager.setup();
    }
}
