package xyz.tbvns.rogue_block.Upgrades.RegisteredUpgrades;

import net.minecraft.entity.effect.StatusEffectInstance;
import net.minecraft.entity.effect.StatusEffects;
import net.minecraft.item.ItemStack;
import net.minecraft.item.Items;
import net.minecraft.server.network.ServerPlayerEntity;
import net.minecraft.util.Identifier;
import xyz.tbvns.rogue_block.Upgrades.PassiveUpgrade;
import xyz.tbvns.rogue_block.Upgrades.Upgrade;
import xyz.tbvns.rogue_block.Upgrades.UpgradeRarity;

import static xyz.tbvns.rogue_block.Rogue_block.MOD_ID;

public class RegenUpgrade2 implements PassiveUpgrade {
    @Override
    public int getCost() {
        return 10;
    }

    @Override
    public void executeOnStart(ServerPlayerEntity player) {
        player.addStatusEffect(new StatusEffectInstance(StatusEffects.REGENERATION, StatusEffectInstance.INFINITE, 1));
    }

    @Override
    public String getName() {
        return "Regeneration 2";
    }

    @Override
    public String getDesc() {
        return "Provide you with a constant regeneration 2 effect";
    }

    @Override
    public int[] getGuiPos() {
        return new int[]{50, 100};
    }

    @Override
    public ItemStack itemDisplay() {
        return Items.POTION.getDefaultStack();
    }

    @Override
    public UpgradeRarity getRarity() {
        return UpgradeRarity.medium;
    }

    @Override
    public Class getParent() {
        return RegenUpgrade.class;
    }

    @Override
    public Identifier getId() {
        return Identifier.of(MOD_ID, "regen2");
    }
}
